function T = dirKinEE(q, dh)
    [d1, a2, a3, d4, d6, qoffset] = extractKinConstants(dh);
    % Add joint offsets
    q = q + qoffset;

    T = zeros(4, 4, size(q, 1));
    c1 = cos(q(:, 1)); s1 = sin(q(:, 1));
    c2 = cos(q(:, 2)); s2 = sin(q(:, 2));
    c3 = cos(q(:, 3)); s3 = sin(q(:, 3));
    c23 = cos(q(:, 2) + q(:, 3)); s23 = sin(q(:, 2) + q(:, 3));
    c4 = cos(q(:, 4)); s4 = sin(q(:, 4));
    c5 = cos(q(:, 5)); s5 = sin(q(:, 5));
    c6 = cos(q(:, 6)); s6 = sin(q(:, 6));

    T(1, 1, :) = s1 .* (c5 .* c6 .* s4 + c4 .* s6) ...
        + c1 .* (c23 .* (c4 .* c5 .* c6 - s4 .* s6) - c6 .* s5 .* s23);
    T(2, 1, :) = c6 .* (c5 .* (c2 .* c3 .* c4 .* s1 - c4 .* s2 .* s3 .* s1 ...
        - c1 .* s4) - s1 .* s5 .* s23) - s6 .* (s1 .* s4 .* c23 + c1 .* c4);
    T(3, 1, :) = s4 .* s6 .* s23 - c6 .* (c3 .* (c4 .* c5 .* s2 + c2 .* s5) ...
        + s3 .* (c2 .* c4 .* c5 - s2 .* s5));
    T(1, 2, :) = c6 .* (c4 .* s1 - c1 .* s4 .* c23) ...
        - s6 .* (c1 .* (c4 .* c5 .* c23 - s5 .* s23) + c5 .* s1 .* s4);
    T(2, 2, :) = s1 .* (s6 .* (s5 .* s23 + c4 .* c5 .* s2 .* s3 ...
        - c2 .* c3 .* c4 .* c5) - c6 .* s4 .* c23) ...
        + c1 .* (c5 .* s4 .* s6 - c4 .* c6);
    T(3, 2, :) = c3 .* (c6 .* s2 .* s4 + s6 .* (c4 .* c5 .* s2 + c2 .* s5)) ...
        + s3 .* (c2 .* (c6 .* s4 + c4 .* c5 .* s6) - s2 .* s5 .* s6);
    T(1, 3, :) = -c1 .* (c4 .* s5 .* c23 + c5 .* s23) - s1 .* s4 .* s5;
    T(2, 3, :) = s5 .* (c4 .* s1 .* s2 .* s3 + c1 .* s4) ...
        - c3 .* s1 .* (c5 .* s2 + c2 .* c4 .* s5) -c2 .* c5 .* s1 .* s3;
    T(3, 3, :) = s2 .* (c5 .* s3 + c3 .* c4 .* s5) ...
        + c2 .* (c4 .* s3 .* s5 - c3 .* c5);
    T(1, 4, :) = c1 .* (c23 .* (a3 - c4 .* d6 .* s5) ...
        - s23 .* (c5 .* d6 + d4) + a2 .* c2) - d6 .* s1 .* s4 .* s5;
    T(2, 4, :) = c2 .* s1 .* (c3 .* (a3 - c4 .* d6 .* s5) + a2 ...
        - s3 .* (c5 .* d6 + d4)) - a3 .* s1 .* s3 .* s2 ...
        - c3 .* s1 .* s2 .* (c5 .* d6 + d4) ...
        + c4 .* d6 .* s1 .* s3 .* s5 .* s2 + c1 .* d6 .* s4 .* s5;
    T(3, 4, :) = s2 .* (c3 .* (c4 .* d6 .* s5 - a3) - a2 ...
        + s3 .* (c5 .* d6 + d4)) - c2 .* (s3 .* (a3 - c4 .* d6 .* s5) ...
        + c3 .* (c5 .* d6 + d4)) + d1;
    T(4, 4, :) = 1;
